/*
BTCL - Copyright (C) 2001, 2002
by Andrea Marchesini
a.marchesini@ngi.it

BTCL.C
*/


#include <string.h>
#include "btcl.h"


#ifdef __MYSQL__
int mysql_db_num_rows(ClientData clientdata, Tcl_Interp *interp, int argc, 
                      char *argv[]);
int mysql_db_error(ClientData clientdata, Tcl_Interp *interp, int argc,
                   char *argv[]);
int mysql_db_close(ClientData clientdata, Tcl_Interp *interp, int argc, 
                   char *argv[]);
int mysql_db_read(ClientData clientdata, Tcl_Interp *interp, int argc, 
                  char *argv[]);
int mysql_db_query(ClientData clientdata, Tcl_Interp *interp, int argc, 
                   char *argv[]);
int mysql_db_connect(ClientData clientdata, Tcl_Interp *interp, int argc, 
                     char *argv[]);
int mysql_db_info(ClientData clientdata, Tcl_Interp *interp, int argc,
                  char *argv[]);
#endif

#ifdef __CRYPT__
int crypt_des(ClientData clientdata, Tcl_Interp *interp, int argc, 
              char *argv[]);
int crypt_xor(ClientData clientdata, Tcl_Interp *interp, int argc, 
              char *argv[]);
#endif

#ifdef __PGSQL__
int pgsql_db_num_rows(ClientData clientdata, Tcl_Interp *interp, int argc, 
                      char *argv[]);
int pgsql_db_error(ClientData clientdata, Tcl_Interp *interp, int argc,
                   char *argv[]);
int pgsql_db_close(ClientData clientdata, Tcl_Interp *interp, int argc, 
                   char *argv[]);
int pgsql_db_read(ClientData clientdata, Tcl_Interp *interp, int argc, 
                  char *argv[]);
int pgsql_db_query(ClientData clientdata, Tcl_Interp *interp, int argc, 
                   char *argv[]);
int pgsql_db_connect(ClientData clientdata, Tcl_Interp *interp, int argc, 
                     char *argv[]);
int pgsql_db_clean(ClientData clientdata, Tcl_Interp *interp, int argc, 
                   char *argv[]);
int pgsql_db_info(ClientData clientdata, Tcl_Interp *interp, int argc, 
                  char *argv[]);
#endif

/* WEB.C */
int cgi_get(ClientData clientdata, Tcl_Interp *interp, int argc, char *argv[]);
int array_str(ClientData clientdata, Tcl_Interp *interp, int argc, 
              char *argv[]);
int format_str(ClientData clientdata, Tcl_Interp *interp, int argc, 
               char *argv[]);
int cgi_post(ClientData clientdata, Tcl_Interp *interp, int argc, 
             char *argv[]);
int decode_hex(ClientData clientData, Tcl_Interp *interp, int argc, 
               char *argv[]);
int code_hex(ClientData clientData, Tcl_Interp *interp, int argc, 
               char *argv[]);
int explode(ClientData clientData, Tcl_Interp *interp, int argc, char *argv[]);
int f_rand(ClientData  clientData, Tcl_Interp *interp, int argc, char *argv[]);
int version(ClientData  clientData, Tcl_Interp *interp, int argc, char *argv[]);

/* XML.C */
int xml_test(ClientData  clientData, Tcl_Interp *interp, int argc,
             char *argv[]);
int xml_info(ClientData  clientData, Tcl_Interp *interp, int argc, 
             char *argv[]);
int xml_error(ClientData  clientData, Tcl_Interp *interp, int argc, 
             char *argv[]);

/* Redirected cmd to procedure: */
int AppInit (Tcl_Interp *interp) {
 if(Tcl_Init(interp)==TCL_ERROR) return TCL_ERROR;
 Tcl_CreateCommand(interp,"random",(Tcl_CmdProc *)    f_rand,    (ClientData) 
                   NULL, (Tcl_CmdDeleteProc *) NULL);
 Tcl_CreateCommand(interp,"version",(Tcl_CmdProc *)    version,    (ClientData) 
                   NULL, (Tcl_CmdDeleteProc *) NULL);
 Tcl_CreateCommand(interp,"explode",(Tcl_CmdProc *)    explode,    (ClientData) 
                   NULL, (Tcl_CmdDeleteProc *) NULL);
 Tcl_CreateCommand(interp,"decode_hex",(Tcl_CmdProc *) decode_hex, (ClientData) 
                   NULL, (Tcl_CmdDeleteProc *) NULL);
 Tcl_CreateCommand(interp,"code_hex",(Tcl_CmdProc *)   code_hex,   (ClientData) 
                   NULL, (Tcl_CmdDeleteProc *) NULL);
 Tcl_CreateCommand(interp,"cgi_post",(Tcl_CmdProc *)   cgi_post,   (ClientData) 
                   NULL, (Tcl_CmdDeleteProc *) NULL);
 Tcl_CreateCommand(interp,"cgi_get",(Tcl_CmdProc *)    cgi_get,    (ClientData) 
                   NULL, (Tcl_CmdDeleteProc *) NULL);
 Tcl_CreateCommand(interp,"format_str",(Tcl_CmdProc *) format_str, (ClientData)
                   NULL, (Tcl_CmdDeleteProc *) NULL);
 Tcl_CreateCommand(interp,"array_str",(Tcl_CmdProc *)  array_str,  (ClientData)
                   NULL, (Tcl_CmdDeleteProc *) NULL);
 
 Tcl_CreateCommand(interp,"xml_test",(Tcl_CmdProc *)  xml_test,    (ClientData)
                   NULL, (Tcl_CmdDeleteProc *) NULL);
 Tcl_CreateCommand(interp,"xml_info",(Tcl_CmdProc *)  xml_info,    (ClientData) 
                   NULL, (Tcl_CmdDeleteProc *) NULL);
 Tcl_CreateCommand(interp,"xml_error",(Tcl_CmdProc *)  xml_error,    (ClientData) 
                   NULL, (Tcl_CmdDeleteProc *) NULL);

#ifdef __MYSQL__
 Tcl_CreateCommand(interp,"mysql_db_connect",(Tcl_CmdProc *)  mysql_db_connect,
                   (ClientData) NULL, (Tcl_CmdDeleteProc *) NULL);
 Tcl_CreateCommand(interp,"mysql_db_query",(Tcl_CmdProc *)    mysql_db_query, 
                   (ClientData) NULL, (Tcl_CmdDeleteProc *) NULL);
 Tcl_CreateCommand(interp,"mysql_db_read",(Tcl_CmdProc *)     mysql_db_read, 
                   (ClientData) NULL, (Tcl_CmdDeleteProc *) NULL);
 Tcl_CreateCommand(interp,"mysql_db_num_rows",(Tcl_CmdProc *) 
                    mysql_db_num_rows, (ClientData) NULL, (Tcl_CmdDeleteProc *)
                    NULL);
 Tcl_CreateCommand(interp,"mysql_db_close",(Tcl_CmdProc *)    mysql_db_close,
                   (ClientData) NULL, (Tcl_CmdDeleteProc *) NULL);
 Tcl_CreateCommand(interp,"mysql_db_error",(Tcl_CmdProc *)    mysql_db_error,
                   (ClientData) NULL, (Tcl_CmdDeleteProc *) NULL);
 Tcl_CreateCommand(interp,"mysql_db_info",(Tcl_CmdProc *)    mysql_db_info, 
                   (ClientData) NULL, (Tcl_CmdDeleteProc *) NULL);
#endif

#ifdef __CRYPT__
 Tcl_CreateCommand(interp,"crypt_des",(Tcl_CmdProc *) crypt_des, (ClientData) 
                   NULL, (Tcl_CmdDeleteProc *) NULL);
 Tcl_CreateCommand(interp,"crypt_xor",(Tcl_CmdProc *) crypt_xor, (ClientData) 
                   NULL, (Tcl_CmdDeleteProc *) NULL);
#endif

#ifdef __PGSQL__
 Tcl_CreateCommand(interp,"pgsql_db_connect",(Tcl_CmdProc *)  pgsql_db_connect,
                   (ClientData) NULL, (Tcl_CmdDeleteProc *) NULL);
 Tcl_CreateCommand(interp,"pgsql_db_query",(Tcl_CmdProc *)    pgsql_db_query, 
                   (ClientData) NULL, (Tcl_CmdDeleteProc *) NULL);
 Tcl_CreateCommand(interp,"pgsql_db_read",(Tcl_CmdProc *)     pgsql_db_read, 
                   (ClientData) NULL, (Tcl_CmdDeleteProc *) NULL);
 Tcl_CreateCommand(interp,"pgsql_db_num_rows",(Tcl_CmdProc *) pgsql_db_num_rows,
                    (ClientData) NULL, (Tcl_CmdDeleteProc *) NULL);
 Tcl_CreateCommand(interp,"pgsql_db_close",(Tcl_CmdProc *)    pgsql_db_close,
                   (ClientData) NULL, (Tcl_CmdDeleteProc *) NULL);
 Tcl_CreateCommand(interp,"pgsql_db_error",(Tcl_CmdProc *)    pgsql_db_error,
                   (ClientData) NULL, (Tcl_CmdDeleteProc *) NULL);
 Tcl_CreateCommand(interp,"pgsql_db_clean",(Tcl_CmdProc *)    pgsql_db_clean, 
                   (ClientData) NULL, (Tcl_CmdDeleteProc *) NULL);
 Tcl_CreateCommand(interp,"pgsql_db_info",(Tcl_CmdProc *)    pgsql_db_info, 
                   (ClientData) NULL, (Tcl_CmdDeleteProc *) NULL);
#endif
 return TCL_OK;
}

int main(int argc, char *argv[]) {
 Tcl_Main(argc, argv, AppInit);
 return 0;
}
