/*
BTCL - Copyright (C) 2001, 2002
by Andrea Marchesini
a.marchesini@ngi.it

CRYPT.C
*/

#include <string.h>
#include <crypt.h>
#include "btcl.h"

/* 
 * Crypt: Passi una stringa e una key di 2 caratteri e ti ritorna la
 * stringa cryptata.
 */
int crypt_des(ClientData clientdata, Tcl_Interp *interp, int argc, char *argv[])
              {
 static char tmp[MAX_STR];

 if(argc>4 || argc<3) {
  puts("Error: wrong args: should be \"crypt_des Var Key ?md5_option?\"");
  return TCL_ERROR;
 }
 if(argc==4 && strcmp(argv[3],"1")==0) strcpy(tmp,"$1$");
 else tmp[0]=0;
 strcat(tmp,argv[2]);

 Tcl_SetResult (interp, crypt(argv[1],tmp), TCL_VOLATILE);
 return TCL_OK;
}	

/*
 * Cripta usando lo xor su una chiave passata.
 */
int crypt_xor(ClientData clientdata, Tcl_Interp *interp, int argc, char *argv[])
              {
 char c;
 int i;

 if(argc!=3) {
  puts("Error: wrong args: should be \"crypt_xor Var Key\"");
  return TCL_ERROR;
 }
 
 for(i=c=0;i<strlen(argv[1]);i++) {
  (unsigned)argv[1][i]^=(unsigned)argv[2][c++];
  if(c==strlen(argv[2])) c=0;
 }

 Tcl_SetResult (interp, argv[1], TCL_VOLATILE);
 return TCL_OK;
}	
