/*
BTCL - Copyright (C) 2001, 2002
by Andrea Marchesini
a.marchesini@ngi.it

OTHER.C
*/

#include <string.h>
#include <stdlib.h>
#include <time.h>
#include "btcl.h"


/*
 * Divide una stringa in + collocate in un array usando come carattere
 * di divisione il valore passato.
 */
int array_str(ClientData clientdata, Tcl_Interp *interp, int argc, char *argv[]) 
              {
 static char tmp[MAX_STR], tmp2[MAX_STR];
 int a,b,c;
  
 if(argc!=4) {
  puts("Error: wrong args: should be \"array_str varName Char NewArray\"");
  return TCL_ERROR;
 }
 for(a=0,b=0,c=0;a<strlen(argv[1]);a++) {
  if(argv[1][a]==argv[2][0]) {
   tmp2[b]=0;
   sprintf(tmp,"%s(%d)",argv[3],c++);
   Tcl_SetVar(interp,tmp,tmp2,0);
   b=0;
  } else tmp2[b++]=argv[1][a];
 }
 tmp2[b]=0;
 sprintf(tmp,"%s(%d)",argv[3],c);
 Tcl_SetVar(interp,tmp,tmp2,0);
 sprintf(tmp,"%d",++c);
 Tcl_SetResult (interp, tmp, TCL_VOLATILE);
 return TCL_OK;
} 

/*
 * Formatta stringhe. Riceve un valore che pu essere 0 1 o 2
 * Con 0 toglie in testa, con 1 al fondo con 2 entrambe le cose.
 */
int format_str(ClientData clientdata, Tcl_Interp *interp, int argc, 
               char *argv[]) {
 char *tmp;
 int a,b,c,d;
  
 if(argc!=3) {
  puts("Error: wrong args: should be \"format_str Option varName\"");
  return TCL_ERROR;
 }

 tmp=(char *)malloc(sizeof(argv[2]));

 /* Tolgo in testa: */
 if(strlen(argv[1])==1 && argv[1][0]=='0') {
  for(a=0,b=0,c=0;a<strlen(argv[2]);a++) {
   if(argv[2][a]!=' ' && b==0) b=1;
   if(b!=0) tmp[c++]=argv[2][a];
  }
  tmp[c]=0;

  /* Tolgo al fondo: */
 } else if(strlen(argv[1])==1 && argv[1][0]=='1') {
      
  for(a=strlen(argv[2]),b=strlen(argv[2]),c=0;a>0;a--) {
   if(argv[2][a-1]==' ' && c==0) b--;
   else if(argv[2][a-1]!=' ') c=1;
  }
  for(a=0,c=0;a<b;a++) tmp[c++]=argv[2][a];
  tmp[c]=0;

 /* Tolgo da entrambi: */
 } else if(strlen(argv[1])==1 && argv[1][0]=='2') {

  for(a=strlen(argv[2]),b=strlen(argv[2]),c=0;a>0;a--) {
   if(argv[2][a-1]==' ' && c==0) b--;
   else if(argv[2][a-1]!=' ') c=1;
  }
  for(a=0,c=0,d=0;a<b;a++) {
   if(argv[2][a]!=' ' && d==0) d=1;
   if(d!=0) tmp[c++]=argv[2][a];
  }
  tmp[c]=0;
 } else {
  puts("Error: wrong args: should be \"format_str Option varName\"");
  return TCL_ERROR;
 }
 Tcl_SetResult (interp, tmp, TCL_VOLATILE);
 return TCL_OK;
}

/* random */
int f_rand(ClientData  clientData, Tcl_Interp *interp, int argc, char *argv[]) 
            {
 float b;
 char *str;
 if(argc!=2) {
  puts("Error: wrong args: should be \"random Max\"");
  return TCL_ERROR;
 }
 b=(int)atoi(argv[1]);
 srand(time(0));

 str=(char *)malloc(sizeof(atoi(argv[1])/3));

 sprintf(str,"%d",1+(int) (b*rand()/(RAND_MAX+1.0)));
 
 Tcl_SetResult (interp, str, TCL_VOLATILE);
 return TCL_OK; 
}

/* Version of BTCL: */
int version(ClientData  clientData, Tcl_Interp *interp, int argc, char *argv[]) 
            {
 char *tmp;
 if(argc!=1) {
  puts("No argoment for this cmd");
  return TCL_ERROR;
 }
 tmp=(char *)malloc(sizeof("BTCL - bakutcl version \nCopyright (C) 2001, 2002 by Andrea Marchesini")+10);
 sprintf(tmp,"BTCL - bakutcl version %s\nCopyright (C) 2001, 2002 by Andrea Marchesini"
         ,BTCL_VER);
 puts(tmp);

 return TCL_OK;
}

/* 
set a [array names env]
foreach b $a {puts "$b-$env($b)<br>"}
*/
