/*
BTCL - Copyright (C) 2001, 2002
by Andrea Marchesini
a.marchesini@ngi.it

XML.C
*/

#include "btcl.h"
#include <string.h>

/* Variabili comuni: */
static char str_xml_error[MAX_STR];

int xml_r_find(FILE *fl,char *str);

/* Fa il test di un file se e' ben formattato in XML */
int xml_test(ClientData clientdata, Tcl_Interp *interp, int argc, char *argv[])
             {
 FILE *fl;
 char ch;
 char cmd[MAX_STR];
 int i=0,flag=0;

 if(argc!=2) {
  puts("Error: wrong args: should be \"xml_test NameFile\"");
  return TCL_ERROR;
 } 
 str_xml_error[0]=0;    /* Annullo l'errore */

 if((fl=fopen(argv[1],"rb"))==NULL) {
  puts("Error: NameFile");
  return TCL_ERROR;
 }
 while((ch=getc(fl))!=EOF) {
  if(ch=='<') {

   /* Controllo primo carattere: */
   ch=getc(fl);            

   while(ch=='?') {                   /* Studio i comandi ? */
    while((ch=getc(fl))!=EOF) {
     if(ch=='?' && (getc(fl))=='>') {
      while((ch=getc(fl))!=EOF) {
       if(ch=='<') {
        ch=getc(fl); 
        break;
       } else if(ch!=' ' && ch!='\n' && ch!='\r'&& ch!='\t' && ch!='\v' && 
                 ch!='<') {
        strcpy(str_xml_error,"Char before the root command");
        Tcl_SetResult (interp, "-1", TCL_VOLATILE);
        return TCL_OK;
       }
      }
      break;
     }
    }
   }

   if(ch=='!') {                       /* Studio i comandi ! */
    if((getc(fl))=='D' && (getc(fl))=='O' && (getc(fl))=='C' && (getc(fl))=='T'
        && (getc(fl))=='Y' && (getc(fl))=='P' && (getc(fl))=='E') {
     flag=1;
     while((ch=getc(fl))!=EOF) {
      if(ch=='>') flag--;
      else if(ch=='<') flag++;
      if(flag==0) {
       while((ch=getc(fl))!=EOF) {
        if(ch=='<') {
         ch=getc(fl); 
         break;
        } else if(ch!=' ' && ch!='\n' && ch!='\r'&& ch!='\t' && ch!='\v' && 
                  ch!='<') {
         strcpy(str_xml_error,"Char before the root command");
         Tcl_SetResult (interp, "-1", TCL_VOLATILE);
         return TCL_OK;
        }
       }
       break;
      }
     }
     if(flag!=0) {
      strcpy(str_xml_error,"Error structure of DOCTYPE command");
      Tcl_SetResult (interp, "-1", TCL_VOLATILE);
      return TCL_OK;
     }
    } else {
     strcpy(str_xml_error,"I don't know the ! command before the root command");
     Tcl_SetResult (interp, "-1", TCL_VOLATILE);
     return TCL_OK;
    }
   }

   if(ch<'A' && ch!='/') {
    strcpy(str_xml_error,"Error XML name for the root command");
    Tcl_SetResult (interp, "-1", TCL_VOLATILE);
    return TCL_OK;
   } else if(ch>'Z' && ch<'a' && ch!='_') {
    strcpy(str_xml_error,"Error XML name for the root command");
    Tcl_SetResult (interp, "-1", TCL_VOLATILE);
    return TCL_OK;
   } else if(ch>'z') {
    strcpy(str_xml_error,"Error XML name for the root command");
    Tcl_SetResult (interp, "-1", TCL_VOLATILE);
    return TCL_OK;
   } else cmd[i++]=ch;
   flag=1;                 /* Flag per il controllo del comando di root */
   
   /* Il resto del comando: */
   while((ch=getc(fl))!=EOF) {
    if(ch=='>' || ch==' ') break;
    else if(ch<'A' && ch!='!' && ch!='-' && ch!='.' && ch!='/') {
     strcpy(str_xml_error,"Error XML name for the root command");
     Tcl_SetResult (interp, "-1", TCL_VOLATILE);
     return TCL_OK;
    } else if(ch>'Z' && ch<'a' && ch!='_') {  
     strcpy(str_xml_error,"Error XML name for the root command");
     Tcl_SetResult (interp, "-1", TCL_VOLATILE);
     return TCL_OK;
    } else if(ch>'z') {
     strcpy(str_xml_error,"Error XML name for the root command");
     Tcl_SetResult (interp, "-1", TCL_VOLATILE);
     return TCL_OK;
    } else cmd[i++]=ch;
   }
   cmd[i]=0;

   /* Avvio della ricorsione: */
   if(i==0 || xml_r_find(fl,cmd)) {
    strcpy(str_xml_error,"Error XML name for the root command");
    Tcl_SetResult (interp, "-1", TCL_VOLATILE);
    return TCL_OK;
   } else {
    str_xml_error[0]=0;
    Tcl_SetResult (interp, "0", TCL_VOLATILE);
    return TCL_OK;
   }
  } else if(ch!=' ' && ch!='\n' && ch!='\r'&& ch!='\t' && ch!='\v' && flag==0) 
           {
   strcpy(str_xml_error,"Char before the root command");
   Tcl_SetResult (interp, "-1", TCL_VOLATILE);
   return TCL_OK;
  }
 }
 Tcl_SetResult (interp, "0", TCL_VOLATILE);
 return TCL_OK;
}

/* La prima funzione ricorsiva di btcl! */
int xml_r_find(FILE *fl,char *str) {
 char ch;
 static char cmd[MAX_STR], arg[MAX_STR];
 int a,b;
 
 a=b=0;
 while((ch=getc(fl))!=EOF) {
  if(ch=='<') {
   /* Studio del primo carattere: */
   ch=getc(fl);
  
   while(ch=='!' || ch=='?') {
    if(ch=='!') {                         /* Commenti o [CDATA[ */
     if( (ch=getc(fl))=='[') {            /* Cerco [CDATA[ */
      if( (getc(fl))=='C' && (getc(fl))=='D' && (getc(fl))=='A' && \
          (getc(fl))=='T' && (getc(fl))=='A' && (getc(fl))=='[') {
       while((ch=getc(fl))!=EOF) {
        if(ch==']' && (getc(fl))==']' && (getc(fl))=='>') {
         while((ch=getc(fl))!=EOF && ch!='<');
         ch=getc(fl);
         break;
        }
       }
      } else {
       strcpy(str_xml_error,"I don't know a ! command");
       return 1;
      }
     } else if(ch=='-') {                /* Cerco Commenti */
      if( (getc(fl))=='-') {
       while((ch=getc(fl))!=EOF) {
        if(ch=='-' && (getc(fl))=='-' && (getc(fl))=='>') {
         while((ch=getc(fl))!=EOF && ch!='<');
         ch=getc(fl);
         break;
        }
       }
      } else {
       strcpy(str_xml_error,"I don't know a ! command");
       return 1; 
      }
     } else {
      strcpy(str_xml_error,"I don't know a ! command");
      return 1;
     }

    } else if(ch=='?') {                 /* Comandi ? */
     while((ch=getc(fl))!=EOF) {
      if(ch=='?' && (getc(fl))=='>') {
       while((ch=getc(fl))!=EOF && ch!='<');
       ch=getc(fl);
       break;
      }    
     }
    }
   }
   
   if(ch<'A' && ch!='/')         return 1;
   else if(ch>'Z' && ch<'a' && ch!='_') return 1;
   else if(ch>'z')                      return 1;
   else cmd[a++]=ch;

   /* Studio resto del comando: */
   while((ch=getc(fl))!=EOF) {
    if(ch=='>' || ch==' ') break;
    else if(ch<'A' && ch!='!' && ch!='-' && ch!='.' && ch!='/') {
     strcpy(str_xml_error,"Wrong XML name for the root command");
     return 1;
    } else if(ch>'Z' && ch<'a' && ch!='_') {
     strcpy(str_xml_error,"Wrong XML name for the root command");
     return 1;
    } else if(ch>'z') {
     strcpy(str_xml_error,"Wrong XML name for the root command");
     return 1;
    } else cmd[a++]=ch;
   }
   cmd[a]=0;

   /* Attributi: */
   if(ch==' ') {
    while((ch=getc(fl))!=EOF && ch!='>') arg[b++]=ch;
    arg[b]=0;
   }
   
   /* Comando da trascurare oppure avvio ricorsione: */
   if(cmd[--a]!='/' || arg[--b]!='/') {
    if(strlen(cmd)==0) { 
     strcpy(str_xml_error,"Wrong XML name for the root command");
     return 1;                         /* Se non si e' trovato il comando */
    } else if(cmd[0]=='/') {           /* Se e' un comando di chiusura    */
     for(a=0;a<strlen(cmd);a++) cmd[a]=cmd[a+1];
     if(strcmp(cmd,str)==0) {
      str_xml_error[0]=0;
      return 0;                        /* Se i due comandi corrispondono  */
     } else {
      sprintf(str_xml_error,"Tag does not open: %s",cmd);
      return 1; 
     }
    } else if(xml_r_find(fl,cmd)) return 1;  /* Riparte... */
   }
   a=b=0;
  }
 }
 sprintf(str_xml_error,"Tag does not close: %s",str);
 return 1;
}

/* Da tutte le informazioni riferite al file. Si veda il README */
int xml_info(ClientData clientdata, Tcl_Interp *interp, int argc, char *argv[])
            {
 FILE *fl;
 char ch;
 static char str[MAX_STR], tmp[MAX_STR];
 int a=0;

 if(argc!=3) {
  puts("Error: wrong args: should be \"xml_info NameFile Array\"");
  return TCL_ERROR;
 }
 if((fl=fopen(argv[1],"rb"))==NULL) {
  puts("Error: NameFile");
  return TCL_ERROR;
 }
 while((ch=getc(fl))!=EOF) {

  if(ch=='<' && (getc(fl))=='?' && (getc(fl))=='x' && (getc(fl))=='m'
     && (getc(fl))=='l' && ( (ch=getc(fl))==' ' || ch=='\n' || ch=='\r'
     || ch=='\t' || ch=='\v') ) {
   while((ch=getc(fl))!=EOF) {
    if(ch=='?' && (ch=getc(fl))=='>') break;

    do {
     if(ch!=' ' && ch!='\n' && ch!='\r' && ch!='\t' && ch!='\v') break;
    } while((ch=getc(fl))!=EOF);
    
    /* Versione: */
    if(ch=='v' && (getc(fl))=='e' && (getc(fl))=='r' && (getc(fl))=='s'  
       && (getc(fl))=='i' && (getc(fl))=='o' && (getc(fl))=='n') {
     while((ch=getc(fl))!=EOF && ch==' ');
     if(ch=='=') {
      a=0;
      while((ch=getc(fl))!=EOF && ch==' ');
      if(ch!='\"') str[a++]=ch;
      while((ch=getc(fl))!=EOF && ch!=' ' && ch!='\"') str[a++]=ch;
      str[a]=0;
      sprintf(tmp,"%s(VERSION)",argv[2]);
      Tcl_SetVar(interp,tmp,str,0);
      while((ch=getc(fl))!=EOF && ch!=' ' && ch!='\n' && ch!='\r' && 
             ch!='\t' && ch!='\v');
     } else {
      while((ch=getc(fl))!=EOF && ch!=' ' && ch!='\n' && ch!='\r' && 
             ch!='\t' && ch!='\v');
     }
     
    /* Encoding: */
    } else if(ch=='e' && (getc(fl))=='n' && (getc(fl))=='c' && (getc(fl))=='o'
              && (getc(fl))=='d' && (getc(fl))=='i' && (getc(fl))=='n' && 
              (getc(fl))=='g') {
     while((ch=getc(fl))!=EOF && ch==' ');
     if(ch=='=') {
      a=0;
      while((ch=getc(fl))!=EOF && ch==' ');
      if(ch!='\"') str[a++]=ch;
      while((ch=getc(fl))!=EOF && ch!=' ' && ch!='\"') str[a++]=ch;
      str[a]=0;
      sprintf(tmp,"%s(ENCODING)",argv[2]);
      Tcl_SetVar(interp,tmp,str,0);
      while((ch=getc(fl))!=EOF && ch!=' ' && ch!='\n' && ch!='\r' && ch!='\t' &&
             ch!='\v');
     } else {
      while((ch=getc(fl))!=EOF && ch!=' ' && ch!='\n' && ch!='\r' && ch!='\t' &&
             ch!='\v');
     }
     
    /* Standalone */
    } else if(ch=='s' && (getc(fl))=='t' && (getc(fl))=='a' && (getc(fl))=='n'
              && (getc(fl))=='d' && (getc(fl))=='a' && (getc(fl))=='l' && 
              (getc(fl))=='o' && (getc(fl))=='n' && (getc(fl))=='e') {
     while((ch=getc(fl))!=EOF && ch==' ');
     if(ch=='=') {
      a=0;
      while((ch=getc(fl))!=EOF && ch==' ');
      if(ch!='\"') str[a++]=ch;
      while((ch=getc(fl))!=EOF && ch!=' ' && ch!='\"') str[a++]=ch;
      str[a]=0;
      sprintf(tmp,"%s(STANDALONE)",argv[2]);
      Tcl_SetVar(interp,tmp,str,0);
      while((ch=getc(fl))!=EOF && ch!=' ' && ch!='\n' && ch!='\r' && ch!='\t' &&
             ch!='\v');
     } else {
      while((ch=getc(fl))!=EOF && ch!=' ' && ch!='\n' && ch!='\r' && ch!='\t' &&
             ch!='\v');
     }
    }
   }
  }
 }
 Tcl_SetResult (interp, "0", TCL_VOLATILE);
 return TCL_OK;
}

int xml_error(ClientData clientdata, Tcl_Interp *interp, int argc,
              char *argv[]) {
 if(argc!=1) {
  puts("Error: wrong args: should be \"xml_info NameFile Array\"");
  return TCL_ERROR;
 }
 Tcl_SetResult (interp, str_xml_error, TCL_VOLATILE);
 return TCL_OK;
 
}
